Loading...
1#!/bin/sh
2
3# Copyright (C) 2006 Paul Mackerras, IBM Corporation <paulus@samba.org>
4# This program may be used under the terms of version 2 of the GNU
5# General Public License.
6
7# This script takes a kernel binary and optionally an initrd image
8# and/or a device-tree blob, and creates a bootable zImage for a
9# given platform.
10
11# Options:
12# -o zImage specify output file
13# -p platform specify platform (links in $platform.o)
14# -i initrd specify initrd file
15# -d devtree specify device-tree blob
16# -s tree.dts specify device-tree source file (needs dtc installed)
17# -c cache $kernel.strip.gz (use if present & newer, else make)
18# -C prefix specify command prefix for cross-building tools
19# (strip, objcopy, ld)
20# -D dir specify directory containing data files used by script
21# (default ./arch/powerpc/boot)
22# -W dir specify working directory for temporary files (default .)
23# -z use gzip (legacy)
24# -Z zsuffix compression to use (gz, xz or none)
25
26# Stop execution if any command fails
27set -e
28
29# Allow for verbose output
30if [ "$V" = 1 ]; then
31 set -x
32fi
33
34# defaults
35kernel=
36ofile=zImage
37platform=of
38initrd=
39dtb=
40dts=
41cacheit=
42binary=
43compression=.gz
44pie=
45format=
46
47# cross-compilation prefix
48CROSS=
49
50# mkimage wrapper script
51MKIMAGE=$srctree/scripts/mkuboot.sh
52
53# directory for object and other files used by this script
54object=arch/powerpc/boot
55objbin=$object
56dtc=scripts/dtc/dtc
57
58# directory for working files
59tmpdir=.
60
61usage() {
62 echo 'Usage: wrapper [-o output] [-p platform] [-i initrd]' >&2
63 echo ' [-d devtree] [-s tree.dts] [-c] [-C cross-prefix]' >&2
64 echo ' [-D datadir] [-W workingdir] [-Z (gz|xz|none)]' >&2
65 echo ' [--no-compression] [vmlinux]' >&2
66 exit 1
67}
68
69run_cmd() {
70 if [ "$V" = 1 ]; then
71 $* 2>&1
72 else
73 local msg
74
75 set +e
76 msg=$($* 2>&1)
77
78 if [ $? -ne "0" ]; then
79 echo $msg
80 exit 1
81 fi
82 set -e
83 fi
84}
85
86while [ "$#" -gt 0 ]; do
87 case "$1" in
88 -o)
89 shift
90 [ "$#" -gt 0 ] || usage
91 ofile="$1"
92 ;;
93 -p)
94 shift
95 [ "$#" -gt 0 ] || usage
96 platform="$1"
97 ;;
98 -i)
99 shift
100 [ "$#" -gt 0 ] || usage
101 initrd="$1"
102 ;;
103 -d)
104 shift
105 [ "$#" -gt 0 ] || usage
106 dtb="$1"
107 ;;
108 -s)
109 shift
110 [ "$#" -gt 0 ] || usage
111 dts="$1"
112 ;;
113 -c)
114 cacheit=y
115 ;;
116 -C)
117 shift
118 [ "$#" -gt 0 ] || usage
119 CROSS="$1"
120 ;;
121 -D)
122 shift
123 [ "$#" -gt 0 ] || usage
124 object="$1"
125 objbin="$1"
126 ;;
127 -W)
128 shift
129 [ "$#" -gt 0 ] || usage
130 tmpdir="$1"
131 ;;
132 -z)
133 compression=.gz
134 ;;
135 -Z)
136 shift
137 [ "$#" -gt 0 ] || usage
138 [ "$1" != "gz" -o "$1" != "xz" -o "$1" != "none" ] || usage
139
140 compression=".$1"
141
142 if [ $compression = ".none" ]; then
143 compression=
144 fi
145 ;;
146 --no-gzip)
147 # a "feature" of the the wrapper script is that it can be used outside
148 # the kernel tree. So keeping this around for backwards compatibility.
149 compression=
150 ;;
151 -?)
152 usage
153 ;;
154 *)
155 [ -z "$kernel" ] || usage
156 kernel="$1"
157 ;;
158 esac
159 shift
160done
161
162
163if [ -n "$dts" ]; then
164 if [ ! -r "$dts" -a -r "$object/dts/$dts" ]; then
165 dts="$object/dts/$dts"
166 fi
167 if [ -z "$dtb" ]; then
168 dtb="$platform.dtb"
169 fi
170 $dtc -O dtb -o "$dtb" -b 0 "$dts"
171fi
172
173if [ -z "$kernel" ]; then
174 kernel=vmlinux
175fi
176
177LANG=C elfformat="`${CROSS}objdump -p "$kernel" | grep 'file format' | awk '{print $4}'`"
178case "$elfformat" in
179 elf64-powerpcle) format=elf64lppc ;;
180 elf64-powerpc) format=elf32ppc ;;
181 elf32-powerpc) format=elf32ppc ;;
182esac
183
184ld_version()
185{
186 # Poached from scripts/ld-version.sh, but we don't want to call that because
187 # this script (wrapper) is distributed separately from the kernel source.
188 # Extract linker version number from stdin and turn into single number.
189 awk '{
190 gsub(".*\\)", "");
191 gsub(".*version ", "");
192 gsub("-.*", "");
193 split($1,a, ".");
194 print a[1]*100000000 + a[2]*1000000 + a[3]*10000;
195 exit
196 }'
197}
198
199# Do not include PT_INTERP segment when linking pie. Non-pie linking
200# just ignores this option.
201LD_VERSION=$(${CROSS}ld --version | ld_version)
202LD_NO_DL_MIN_VERSION=$(echo 2.26 | ld_version)
203if [ "$LD_VERSION" -ge "$LD_NO_DL_MIN_VERSION" ] ; then
204 nodl="--no-dynamic-linker"
205fi
206
207platformo=$object/"$platform".o
208lds=$object/zImage.lds
209ext=strip
210objflags=-S
211tmp=$tmpdir/zImage.$$.o
212ksection=.kernel:vmlinux.strip
213isection=.kernel:initrd
214link_address='0x400000'
215make_space=y
216
217case "$platform" in
218of)
219 platformo="$object/of.o $object/epapr.o"
220 make_space=n
221 ;;
222pseries)
223 platformo="$object/pseries-head.o $object/of.o $object/epapr.o"
224 link_address='0x4000000'
225 if [ "$format" != "elf32ppc" ]; then
226 link_address=
227 pie=-pie
228 fi
229 make_space=n
230 ;;
231maple)
232 platformo="$object/of.o $object/epapr.o"
233 link_address='0x400000'
234 make_space=n
235 ;;
236pmac|chrp)
237 platformo="$object/of.o $object/epapr.o"
238 make_space=n
239 ;;
240coff)
241 platformo="$object/crt0.o $object/of.o $object/epapr.o"
242 lds=$object/zImage.coff.lds
243 link_address='0x500000'
244 make_space=n
245 pie=
246 ;;
247miboot|uboot*)
248 # miboot and U-boot want just the bare bits, not an ELF binary
249 ext=bin
250 objflags="-O binary"
251 tmp="$ofile"
252 ksection=image
253 isection=initrd
254 ;;
255cuboot*)
256 binary=y
257 compression=
258 case "$platform" in
259 *-mpc866ads|*-mpc885ads|*-adder875*|*-ep88xc)
260 platformo=$object/cuboot-8xx.o
261 ;;
262 *5200*|*-motionpro)
263 platformo=$object/cuboot-52xx.o
264 ;;
265 *-pq2fads|*-ep8248e|*-mpc8272*|*-storcenter)
266 platformo=$object/cuboot-pq2.o
267 ;;
268 *-mpc824*)
269 platformo=$object/cuboot-824x.o
270 ;;
271 *-mpc83*|*-asp834x*)
272 platformo=$object/cuboot-83xx.o
273 ;;
274 *-tqm8541|*-mpc8560*|*-tqm8560|*-tqm8555|*-ksi8560*)
275 platformo=$object/cuboot-85xx-cpm2.o
276 ;;
277 *-mpc85*|*-tqm85*|*-sbc85*)
278 platformo=$object/cuboot-85xx.o
279 ;;
280 *-amigaone)
281 link_address='0x800000'
282 ;;
283 esac
284 ;;
285ps3)
286 platformo="$object/ps3-head.o $object/ps3-hvcall.o $object/ps3.o"
287 lds=$object/zImage.ps3.lds
288 compression=
289 ext=bin
290 objflags="-O binary --set-section-flags=.bss=contents,alloc,load,data"
291 ksection=.kernel:vmlinux.bin
292 isection=.kernel:initrd
293 link_address=''
294 make_space=n
295 pie=
296 ;;
297ep88xc|ep405|ep8248e)
298 platformo="$object/fixed-head.o $object/$platform.o"
299 binary=y
300 ;;
301adder875-redboot)
302 platformo="$object/fixed-head.o $object/redboot-8xx.o"
303 binary=y
304 ;;
305simpleboot-virtex405-*)
306 platformo="$object/virtex405-head.o $object/simpleboot.o $object/virtex.o"
307 binary=y
308 ;;
309simpleboot-virtex440-*)
310 platformo="$object/fixed-head.o $object/simpleboot.o $object/virtex.o"
311 binary=y
312 ;;
313simpleboot-*)
314 platformo="$object/fixed-head.o $object/simpleboot.o"
315 binary=y
316 ;;
317asp834x-redboot)
318 platformo="$object/fixed-head.o $object/redboot-83xx.o"
319 binary=y
320 ;;
321xpedite52*)
322 link_address='0x1400000'
323 platformo=$object/cuboot-85xx.o
324 ;;
325gamecube|wii)
326 link_address='0x600000'
327 platformo="$object/$platform-head.o $object/$platform.o"
328 ;;
329treeboot-currituck)
330 link_address='0x1000000'
331 ;;
332treeboot-akebono)
333 link_address='0x1000000'
334 ;;
335treeboot-iss4xx-mpic)
336 platformo="$object/treeboot-iss4xx.o"
337 ;;
338epapr)
339 platformo="$object/pseries-head.o $object/epapr.o $object/epapr-wrapper.o"
340 link_address='0x20000000'
341 pie=-pie
342 ;;
343mvme5100)
344 platformo="$object/fixed-head.o $object/mvme5100.o"
345 binary=y
346 ;;
347mvme7100)
348 platformo="$object/motload-head.o $object/mvme7100.o"
349 link_address='0x4000000'
350 binary=y
351 ;;
352esac
353
354vmz="$tmpdir/`basename \"$kernel\"`.$ext"
355
356# Calculate the vmlinux.strip size
357${CROSS}objcopy $objflags "$kernel" "$vmz.$$"
358strip_size=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" "$vmz.$$")
359
360if [ -z "$cacheit" -o ! -f "$vmz$compression" -o "$vmz$compression" -ot "$kernel" ]; then
361 # recompress the image if we need to
362 case $compression in
363 .xz)
364 xz --check=crc32 -f -6 "$vmz.$$"
365 ;;
366 .gz)
367 gzip -n -f -9 "$vmz.$$"
368 ;;
369 *)
370 # drop the compression suffix so the stripped vmlinux is used
371 compression=
372 ;;
373 esac
374
375 if [ -n "$cacheit" ]; then
376 mv -f "$vmz.$$$compression" "$vmz$compression"
377 else
378 vmz="$vmz.$$"
379 fi
380else
381 rm -f $vmz.$$
382fi
383
384vmz="$vmz$compression"
385
386if [ "$make_space" = "y" ]; then
387 # Round the size to next higher MB limit
388 round_size=$(((strip_size + 0xfffff) & 0xfff00000))
389
390 round_size=0x$(printf "%x" $round_size)
391 link_addr=$(printf "%d" $link_address)
392
393 if [ $link_addr -lt $strip_size ]; then
394 echo "INFO: Uncompressed kernel (size 0x$(printf "%x\n" $strip_size))" \
395 "overlaps the address of the wrapper($link_address)"
396 echo "INFO: Fixing the link_address of wrapper to ($round_size)"
397 link_address=$round_size
398 fi
399fi
400
401# Extract kernel version information, some platforms want to include
402# it in the image header
403version=`${CROSS}strings "$kernel" | grep '^Linux version [-0-9.]' | \
404 cut -d' ' -f3`
405if [ -n "$version" ]; then
406 uboot_version="-n Linux-$version"
407fi
408
409# physical offset of kernel image
410membase=`${CROSS}objdump -p "$kernel" | grep -m 1 LOAD | awk '{print $7}'`
411
412case "$platform" in
413uboot)
414 rm -f "$ofile"
415 ${MKIMAGE} -A ppc -O linux -T kernel -C gzip -a $membase -e $membase \
416 $uboot_version -d "$vmz" "$ofile"
417 if [ -z "$cacheit" ]; then
418 rm -f "$vmz"
419 fi
420 exit 0
421 ;;
422uboot-obs600)
423 rm -f "$ofile"
424 # obs600 wants a multi image with an initrd, so we need to put a fake
425 # one in even when building a "normal" image.
426 if [ -n "$initrd" ]; then
427 real_rd="$initrd"
428 else
429 real_rd=`mktemp`
430 echo "\0" >>"$real_rd"
431 fi
432 ${MKIMAGE} -A ppc -O linux -T multi -C gzip -a $membase -e $membase \
433 $uboot_version -d "$vmz":"$real_rd":"$dtb" "$ofile"
434 if [ -z "$initrd" ]; then
435 rm -f "$real_rd"
436 fi
437 if [ -z "$cacheit" ]; then
438 rm -f "$vmz"
439 fi
440 exit 0
441 ;;
442esac
443
444addsec() {
445 ${CROSS}objcopy $4 $1 \
446 --add-section=$3="$2" \
447 --set-section-flags=$3=contents,alloc,load,readonly,data
448}
449
450addsec $tmp "$vmz" $ksection $object/empty.o
451if [ -z "$cacheit" ]; then
452 rm -f "$vmz"
453fi
454
455if [ -n "$initrd" ]; then
456 addsec $tmp "$initrd" $isection
457fi
458
459if [ -n "$dtb" ]; then
460 addsec $tmp "$dtb" .kernel:dtb
461 if [ -n "$dts" ]; then
462 rm $dtb
463 fi
464fi
465
466if [ "$platform" != "miboot" ]; then
467 if [ -n "$link_address" ] ; then
468 text_start="-Ttext $link_address"
469 fi
470#link everything
471 ${CROSS}ld -m $format -T $lds $text_start $pie $nodl -o "$ofile" \
472 $platformo $tmp $object/wrapper.a
473 rm $tmp
474fi
475
476# Some platforms need the zImage's entry point and base address
477base=0x`${CROSS}nm "$ofile" | grep ' _start$' | cut -d' ' -f1`
478entry=`${CROSS}objdump -f "$ofile" | grep '^start address ' | cut -d' ' -f3`
479
480if [ -n "$binary" ]; then
481 mv "$ofile" "$ofile".elf
482 ${CROSS}objcopy -O binary "$ofile".elf "$ofile"
483fi
484
485# post-processing needed for some platforms
486case "$platform" in
487pseries|chrp|maple)
488 $objbin/addnote "$ofile"
489 ;;
490coff)
491 ${CROSS}objcopy -O aixcoff-rs6000 --set-start "$entry" "$ofile"
492 $objbin/hack-coff "$ofile"
493 ;;
494cuboot*)
495 gzip -n -f -9 "$ofile"
496 ${MKIMAGE} -A ppc -O linux -T kernel -C gzip -a "$base" -e "$entry" \
497 $uboot_version -d "$ofile".gz "$ofile"
498 ;;
499treeboot*)
500 mv "$ofile" "$ofile.elf"
501 $objbin/mktree "$ofile.elf" "$ofile" "$base" "$entry"
502 if [ -z "$cacheit" ]; then
503 rm -f "$ofile.elf"
504 fi
505 exit 0
506 ;;
507ps3)
508 # The ps3's loader supports loading a gzipped binary image from flash
509 # rom to ram addr zero. The loader then enters the system reset
510 # vector at addr 0x100. A bootwrapper overlay is used to arrange for
511 # a binary image of the kernel to be at addr zero, and yet have a
512 # suitable bootwrapper entry at 0x100. To construct the final rom
513 # image 512 bytes from offset 0x100 is copied to the bootwrapper
514 # place holder at symbol __system_reset_kernel. The 512 bytes of the
515 # bootwrapper entry code at symbol __system_reset_overlay is then
516 # copied to offset 0x100. At runtime the bootwrapper program copies
517 # the data at __system_reset_kernel back to addr 0x100.
518
519 system_reset_overlay=0x`${CROSS}nm "$ofile" \
520 | grep ' __system_reset_overlay$' \
521 | cut -d' ' -f1`
522 system_reset_overlay=`printf "%d" $system_reset_overlay`
523 system_reset_kernel=0x`${CROSS}nm "$ofile" \
524 | grep ' __system_reset_kernel$' \
525 | cut -d' ' -f1`
526 system_reset_kernel=`printf "%d" $system_reset_kernel`
527 overlay_dest="256"
528 overlay_size="512"
529
530 ${CROSS}objcopy -O binary "$ofile" "$ofile.bin"
531
532 run_cmd dd if="$ofile.bin" of="$ofile.bin" conv=notrunc \
533 skip=$overlay_dest seek=$system_reset_kernel \
534 count=$overlay_size bs=1
535
536 run_cmd dd if="$ofile.bin" of="$ofile.bin" conv=notrunc \
537 skip=$system_reset_overlay seek=$overlay_dest \
538 count=$overlay_size bs=1
539
540 odir="$(dirname "$ofile.bin")"
541 rm -f "$odir/otheros.bld"
542 gzip -n --force -9 --stdout "$ofile.bin" > "$odir/otheros.bld"
543 ;;
544esac
1#!/bin/sh
2
3# Copyright (C) 2006 Paul Mackerras, IBM Corporation <paulus@samba.org>
4# This program may be used under the terms of version 2 of the GNU
5# General Public License.
6
7# This script takes a kernel binary and optionally an initrd image
8# and/or a device-tree blob, and creates a bootable zImage for a
9# given platform.
10
11# Options:
12# -o zImage specify output file
13# -p platform specify platform (links in $platform.o)
14# -i initrd specify initrd file
15# -d devtree specify device-tree blob
16# -s tree.dts specify device-tree source file (needs dtc installed)
17# -c cache $kernel.strip.gz (use if present & newer, else make)
18# -C prefix specify command prefix for cross-building tools
19# (strip, objcopy, ld)
20# -D dir specify directory containing data files used by script
21# (default ./arch/powerpc/boot)
22# -W dir specify working directory for temporary files (default .)
23
24# Stop execution if any command fails
25set -e
26
27# Allow for verbose output
28if [ "$V" = 1 ]; then
29 set -x
30fi
31
32# defaults
33kernel=
34ofile=zImage
35platform=of
36initrd=
37dtb=
38dts=
39cacheit=
40binary=
41gzip=.gz
42pie=
43
44# cross-compilation prefix
45CROSS=
46
47# mkimage wrapper script
48MKIMAGE=$srctree/scripts/mkuboot.sh
49
50# directory for object and other files used by this script
51object=arch/powerpc/boot
52objbin=$object
53dtc=scripts/dtc/dtc
54
55# directory for working files
56tmpdir=.
57
58usage() {
59 echo 'Usage: wrapper [-o output] [-p platform] [-i initrd]' >&2
60 echo ' [-d devtree] [-s tree.dts] [-c] [-C cross-prefix]' >&2
61 echo ' [-D datadir] [-W workingdir] [--no-gzip] [vmlinux]' >&2
62 exit 1
63}
64
65while [ "$#" -gt 0 ]; do
66 case "$1" in
67 -o)
68 shift
69 [ "$#" -gt 0 ] || usage
70 ofile="$1"
71 ;;
72 -p)
73 shift
74 [ "$#" -gt 0 ] || usage
75 platform="$1"
76 ;;
77 -i)
78 shift
79 [ "$#" -gt 0 ] || usage
80 initrd="$1"
81 ;;
82 -d)
83 shift
84 [ "$#" -gt 0 ] || usage
85 dtb="$1"
86 ;;
87 -s)
88 shift
89 [ "$#" -gt 0 ] || usage
90 dts="$1"
91 ;;
92 -c)
93 cacheit=y
94 ;;
95 -C)
96 shift
97 [ "$#" -gt 0 ] || usage
98 CROSS="$1"
99 ;;
100 -D)
101 shift
102 [ "$#" -gt 0 ] || usage
103 object="$1"
104 objbin="$1"
105 ;;
106 -W)
107 shift
108 [ "$#" -gt 0 ] || usage
109 tmpdir="$1"
110 ;;
111 --no-gzip)
112 gzip=
113 ;;
114 -?)
115 usage
116 ;;
117 *)
118 [ -z "$kernel" ] || usage
119 kernel="$1"
120 ;;
121 esac
122 shift
123done
124
125if [ -n "$dts" ]; then
126 if [ ! -r "$dts" -a -r "$object/dts/$dts" ]; then
127 dts="$object/dts/$dts"
128 fi
129 if [ -z "$dtb" ]; then
130 dtb="$platform.dtb"
131 fi
132 $dtc -O dtb -o "$dtb" -b 0 "$dts"
133fi
134
135if [ -z "$kernel" ]; then
136 kernel=vmlinux
137fi
138
139platformo=$object/"$platform".o
140lds=$object/zImage.lds
141ext=strip
142objflags=-S
143tmp=$tmpdir/zImage.$$.o
144ksection=.kernel:vmlinux.strip
145isection=.kernel:initrd
146link_address='0x400000'
147make_space=y
148
149case "$platform" in
150pseries)
151 platformo=$object/of.o
152 link_address='0x4000000'
153 ;;
154maple)
155 platformo=$object/of.o
156 link_address='0x400000'
157 ;;
158pmac|chrp)
159 platformo=$object/of.o
160 ;;
161coff)
162 platformo="$object/crt0.o $object/of.o"
163 lds=$object/zImage.coff.lds
164 link_address='0x500000'
165 pie=
166 ;;
167miboot|uboot*)
168 # miboot and U-boot want just the bare bits, not an ELF binary
169 ext=bin
170 objflags="-O binary"
171 tmp="$ofile"
172 ksection=image
173 isection=initrd
174 ;;
175cuboot*)
176 binary=y
177 gzip=
178 case "$platform" in
179 *-mpc866ads|*-mpc885ads|*-adder875*|*-ep88xc)
180 platformo=$object/cuboot-8xx.o
181 ;;
182 *5200*|*-motionpro)
183 platformo=$object/cuboot-52xx.o
184 ;;
185 *-pq2fads|*-ep8248e|*-mpc8272*|*-storcenter)
186 platformo=$object/cuboot-pq2.o
187 ;;
188 *-mpc824*)
189 platformo=$object/cuboot-824x.o
190 ;;
191 *-mpc83*|*-asp834x*)
192 platformo=$object/cuboot-83xx.o
193 ;;
194 *-tqm8541|*-mpc8560*|*-tqm8560|*-tqm8555|*-ksi8560*)
195 platformo=$object/cuboot-85xx-cpm2.o
196 ;;
197 *-mpc85*|*-tqm85*|*-sbc85*)
198 platformo=$object/cuboot-85xx.o
199 ;;
200 *-amigaone)
201 link_address='0x800000'
202 ;;
203 esac
204 ;;
205ps3)
206 platformo="$object/ps3-head.o $object/ps3-hvcall.o $object/ps3.o"
207 lds=$object/zImage.ps3.lds
208 gzip=
209 ext=bin
210 objflags="-O binary --set-section-flags=.bss=contents,alloc,load,data"
211 ksection=.kernel:vmlinux.bin
212 isection=.kernel:initrd
213 link_address=''
214 make_space=n
215 pie=
216 ;;
217ep88xc|ep405|ep8248e)
218 platformo="$object/fixed-head.o $object/$platform.o"
219 binary=y
220 ;;
221adder875-redboot)
222 platformo="$object/fixed-head.o $object/redboot-8xx.o"
223 binary=y
224 ;;
225simpleboot-virtex405-*)
226 platformo="$object/virtex405-head.o $object/simpleboot.o $object/virtex.o"
227 binary=y
228 ;;
229simpleboot-virtex440-*)
230 platformo="$object/fixed-head.o $object/simpleboot.o $object/virtex.o"
231 binary=y
232 ;;
233simpleboot-*)
234 platformo="$object/fixed-head.o $object/simpleboot.o"
235 binary=y
236 ;;
237asp834x-redboot)
238 platformo="$object/fixed-head.o $object/redboot-83xx.o"
239 binary=y
240 ;;
241xpedite52*)
242 link_address='0x1400000'
243 platformo=$object/cuboot-85xx.o
244 ;;
245gamecube|wii)
246 link_address='0x600000'
247 platformo="$object/$platform-head.o $object/$platform.o"
248 ;;
249treeboot-currituck)
250 link_address='0x1000000'
251 ;;
252treeboot-iss4xx-mpic)
253 platformo="$object/treeboot-iss4xx.o"
254 ;;
255epapr)
256 link_address='0x20000000'
257 pie=-pie
258 ;;
259esac
260
261vmz="$tmpdir/`basename \"$kernel\"`.$ext"
262if [ -z "$cacheit" -o ! -f "$vmz$gzip" -o "$vmz$gzip" -ot "$kernel" ]; then
263 ${CROSS}objcopy $objflags "$kernel" "$vmz.$$"
264
265 strip_size=$(stat -c %s $vmz.$$)
266
267 if [ -n "$gzip" ]; then
268 gzip -n -f -9 "$vmz.$$"
269 fi
270
271 if [ -n "$cacheit" ]; then
272 mv -f "$vmz.$$$gzip" "$vmz$gzip"
273 else
274 vmz="$vmz.$$"
275 fi
276else
277 # Calculate the vmlinux.strip size
278 ${CROSS}objcopy $objflags "$kernel" "$vmz.$$"
279 strip_size=$(stat -c %s $vmz.$$)
280 rm -f $vmz.$$
281fi
282
283if [ "$make_space" = "y" ]; then
284 # Round the size to next higher MB limit
285 round_size=$(((strip_size + 0xfffff) & 0xfff00000))
286
287 round_size=0x$(printf "%x" $round_size)
288 link_addr=$(printf "%d" $link_address)
289
290 if [ $link_addr -lt $strip_size ]; then
291 echo "INFO: Uncompressed kernel (size 0x$(printf "%x\n" $strip_size))" \
292 "overlaps the address of the wrapper($link_address)"
293 echo "INFO: Fixing the link_address of wrapper to ($round_size)"
294 link_address=$round_size
295 fi
296fi
297
298vmz="$vmz$gzip"
299
300# Extract kernel version information, some platforms want to include
301# it in the image header
302version=`${CROSS}strings "$kernel" | grep '^Linux version [-0-9.]' | \
303 cut -d' ' -f3`
304if [ -n "$version" ]; then
305 uboot_version="-n Linux-$version"
306fi
307
308# physical offset of kernel image
309membase=`${CROSS}objdump -p "$kernel" | grep -m 1 LOAD | awk '{print $7}'`
310
311case "$platform" in
312uboot)
313 rm -f "$ofile"
314 ${MKIMAGE} -A ppc -O linux -T kernel -C gzip -a $membase -e $membase \
315 $uboot_version -d "$vmz" "$ofile"
316 if [ -z "$cacheit" ]; then
317 rm -f "$vmz"
318 fi
319 exit 0
320 ;;
321uboot-obs600)
322 rm -f "$ofile"
323 # obs600 wants a multi image with an initrd, so we need to put a fake
324 # one in even when building a "normal" image.
325 if [ -n "$initrd" ]; then
326 real_rd="$initrd"
327 else
328 real_rd=`mktemp`
329 echo "\0" >>"$real_rd"
330 fi
331 ${MKIMAGE} -A ppc -O linux -T multi -C gzip -a $membase -e $membase \
332 $uboot_version -d "$vmz":"$real_rd":"$dtb" "$ofile"
333 if [ -z "$initrd" ]; then
334 rm -f "$real_rd"
335 fi
336 if [ -z "$cacheit" ]; then
337 rm -f "$vmz"
338 fi
339 exit 0
340 ;;
341esac
342
343addsec() {
344 ${CROSS}objcopy $4 $1 \
345 --add-section=$3="$2" \
346 --set-section-flags=$3=contents,alloc,load,readonly,data
347}
348
349addsec $tmp "$vmz" $ksection $object/empty.o
350if [ -z "$cacheit" ]; then
351 rm -f "$vmz"
352fi
353
354if [ -n "$initrd" ]; then
355 addsec $tmp "$initrd" $isection
356fi
357
358if [ -n "$dtb" ]; then
359 addsec $tmp "$dtb" .kernel:dtb
360 if [ -n "$dts" ]; then
361 rm $dtb
362 fi
363fi
364
365if [ "$platform" != "miboot" ]; then
366 if [ -n "$link_address" ] ; then
367 text_start="-Ttext $link_address"
368 fi
369 ${CROSS}ld -m elf32ppc -T $lds $text_start $pie -o "$ofile" \
370 $platformo $tmp $object/wrapper.a
371 rm $tmp
372fi
373
374# Some platforms need the zImage's entry point and base address
375base=0x`${CROSS}nm "$ofile" | grep ' _start$' | cut -d' ' -f1`
376entry=`${CROSS}objdump -f "$ofile" | grep '^start address ' | cut -d' ' -f3`
377
378if [ -n "$binary" ]; then
379 mv "$ofile" "$ofile".elf
380 ${CROSS}objcopy -O binary "$ofile".elf "$ofile"
381fi
382
383# post-processing needed for some platforms
384case "$platform" in
385pseries|chrp|maple)
386 $objbin/addnote "$ofile"
387 ;;
388coff)
389 ${CROSS}objcopy -O aixcoff-rs6000 --set-start "$entry" "$ofile"
390 $objbin/hack-coff "$ofile"
391 ;;
392cuboot*)
393 gzip -n -f -9 "$ofile"
394 ${MKIMAGE} -A ppc -O linux -T kernel -C gzip -a "$base" -e "$entry" \
395 $uboot_version -d "$ofile".gz "$ofile"
396 ;;
397treeboot*)
398 mv "$ofile" "$ofile.elf"
399 $objbin/mktree "$ofile.elf" "$ofile" "$base" "$entry"
400 if [ -z "$cacheit" ]; then
401 rm -f "$ofile.elf"
402 fi
403 exit 0
404 ;;
405ps3)
406 # The ps3's loader supports loading a gzipped binary image from flash
407 # rom to ram addr zero. The loader then enters the system reset
408 # vector at addr 0x100. A bootwrapper overlay is used to arrange for
409 # a binary image of the kernel to be at addr zero, and yet have a
410 # suitable bootwrapper entry at 0x100. To construct the final rom
411 # image 512 bytes from offset 0x100 is copied to the bootwrapper
412 # place holder at symbol __system_reset_kernel. The 512 bytes of the
413 # bootwrapper entry code at symbol __system_reset_overlay is then
414 # copied to offset 0x100. At runtime the bootwrapper program copies
415 # the data at __system_reset_kernel back to addr 0x100.
416
417 system_reset_overlay=0x`${CROSS}nm "$ofile" \
418 | grep ' __system_reset_overlay$' \
419 | cut -d' ' -f1`
420 system_reset_overlay=`printf "%d" $system_reset_overlay`
421 system_reset_kernel=0x`${CROSS}nm "$ofile" \
422 | grep ' __system_reset_kernel$' \
423 | cut -d' ' -f1`
424 system_reset_kernel=`printf "%d" $system_reset_kernel`
425 overlay_dest="256"
426 overlay_size="512"
427
428 ${CROSS}objcopy -O binary "$ofile" "$ofile.bin"
429
430 dd if="$ofile.bin" of="$ofile.bin" conv=notrunc \
431 skip=$overlay_dest seek=$system_reset_kernel \
432 count=$overlay_size bs=1
433
434 dd if="$ofile.bin" of="$ofile.bin" conv=notrunc \
435 skip=$system_reset_overlay seek=$overlay_dest \
436 count=$overlay_size bs=1
437
438 odir="$(dirname "$ofile.bin")"
439 rm -f "$odir/otheros.bld"
440 gzip -n --force -9 --stdout "$ofile.bin" > "$odir/otheros.bld"
441 ;;
442esac